USE Northwind
GO
INSERT INTO dbo.Dostawcy
VALUES ('Dostawca X');

INSERT INTO dbo.Dostawcy (Firma)
VALUES ('Dostawca X');
	
SELECT *
FROM dbo.Dostawcy
WHERE Firma = 'Dostawca X';

INSERT INTO dbo.Dostawcy (ID,Firma)
VALUES (200,'Dostawca Y');

ALTER TABLE dbo.Dostawcy
ADD CONSTRAINT DF_Wojewdztwo DEFAULT 'lskie' FOR Wojewdztwo;

INSERT INTO dbo.Dostawcy (Firma)
VALUES ('Dostawca Y');

SELECT *
FROM dbo.Dostawcy
WHERE Firma = 'Dostawca Y';

INSERT INTO dbo.Dostawcy (Firma, Wojewdztwo)
VALUES ('Dostawca Z','Mazowieckie');

SELECT *
FROM dbo.Dostawcy
WHERE Firma = 'Dostawca Z';

INSERT INTO dbo.Dostawcy (Firma, Wojewdztwo)
VALUES ('Dostawca XY',DEFAULT);

SELECT *
FROM dbo.Dostawcy
WHERE Firma = 'Dostawca XY';

INSERT INTO dbo.Klienci(Firma)
VALUES ('Firma XY');

SELECT *
FROM dbo.Klienci
WHERE Firma='Firma XY';

INSERT INTO [Northwind].[dbo].[Klienci]
([Firma],[Nazwisko],[Imi],[Adres e-mail],[Tytu zawodowy],[Telefon subowy],[Telefon domowy],[Telefon komrkowy],[Numer faksu]
,[Adres],[Miasto],[Wojewdztwo],[Kod pocztowy],[Kraj/region],[Strona sieci Web],[Uwagi])
VALUES('Firma XYZ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);

INSERT INTO dbo.Dostawcy (Firma, Wojewdztwo)
VALUES('Dostawca AB','Maopolskie'),('Dostawca AC',DEFAULT);


SELECT *
INTO Sosy
FROM dbo.Produkty
WHERE Kategoria='Sosy';

SELECT [Nazwa produktu],[Kod produktu], [Cena katalogowa]*1.15 AS Cena
INTO Napoje
FROM dbo.Produkty
WHERE Kategoria='Napoje';

SELECT ID, [Nazwa produktu], [Cena katalogowa]
INTO Pusta
FROM dbo.Produkty
WHERE 1<>1;

INSERT INTO Pusta
SELECT ID, [Nazwa produktu], [Cena katalogowa]
FROM dbo.Produkty
WHERE Kategoria='Napoje';

INSERT INTO Pusta ([Cena katalogowa])
SELECT [Cena katalogowa]
FROM dbo.Produkty
WHERE Kategoria='Napoje';

INSERT INTO Napoje ([Nazwa produktu], [Kod produktu], Cena)
SELECT [Nazwa produktu],[Kod produktu], [Cena katalogowa]
FROM dbo.Produkty AS P
WHERE NOT EXISTS
  (SELECT *
  FROM Napoje AS O
  WHERE O.[Kod produktu] = P.[Kod produktu]);
  
DELETE FROM Sosy;

DELETE FROM Napoje
WHERE Cena <10;

DELETE P
FROM dbo.Produkty AS P
JOIN dbo.[Szczegy zamwie] AS SZ
ON P.ID = SZ.[ID produktu]
AND SZ.[ID zamwienia] = '30';

INSERT INTO Napoje ([Nazwa produktu], [Kod produktu], Cena)
SELECT [Nazwa produktu],[Kod produktu], [Cena katalogowa]
FROM dbo.Produkty
WHERE Kategoria='Napoje'

WITH Duplikaty AS
	(SELECT *, ROW_NUMBER() OVER(PARTITION BY [Kod produktu] ORDER BY [Nazwa produktu]) AS Liczba
	FROM Napoje)
SELECT * FROM Duplikaty
WHERE Liczba>1;

WITH Duplikaty AS
	(SELECT *, ROW_NUMBER() OVER(PARTITION BY [Kod produktu] ORDER BY [Nazwa produktu]) AS Liczba
	FROM Napoje)
DELETE FROM Duplikaty
WHERE Liczba >1;

TRUNCATE TABLE Napoje;

UPDATE dbo.Dostawcy
SET Uwagi = 'Informacje o dostawcy';

UPDATE dbo.Produkty
SET [Poziom ponownego zamwienia] = 15
WHERE [Kod produktu] LIKE 'NWTB-%';

UPDATE dbo.Klienci
SET Miasto = 'Katowice', Wojewdztwo = 'lskie'
WHERE ID=2;

UPDATE dbo.Produkty
SET [Koszt standardowy] = [Koszt standardowy]+5
WHERE Kategoria = 'Przyprawy';

UPDATE dbo.Produkty
SET [Koszt standardowy] /= 2
WHERE Kategoria = 'Przyprawy';

UPDATE P 
SET [Cena katalogowa] *= 0.75
FROM dbo.Produkty AS P JOIN dbo.[Szczegy zamwie] AS SZ
ON P.ID=SZ.[ID produktu]
WHERE SZ.Ilo <5;

UPDATE ZZ
SET ZZ.Uwagi = D.Uwagi  
FROM dbo.[Zamwienia zakupu] AS ZZ JOIN dbo.Dostawcy AS D
ON ZZ.[ID dostawcy]=D.ID
WHERE D.[Tytu zawodowy]='Przedstawiciel handlowy';

CREATE TABLE #Osoby (ID int identity(1,1), Imie varchar(100));
GO
MERGE INTO #Osoby
USING (Values ('Danuta',1),('Marcin',2)) Znajomi(Imie,Numer)
ON #Osoby.ID = Znajomi.Numer
WHEN NOT MATCHED THEN
INSERT (imie) values (Znajomi.Imie);
SELECT * FROM #Osoby;

MERGE INTO #Osoby
USING (Values ('Krzys',3),('Michal',2)) Znajomi(Imie,Numer)
ON #Osoby.ID = Znajomi.Numer
WHEN MATCHED THEN 
  UPDATE SET #Osoby.Imie = Znajomi.Imie
WHEN NOT MATCHED THEN
  INSERT (imie) values (Znajomi.Imie);
SELECT * FROM #Osoby;

MERGE INTO #Osoby
USING (Values ('Danuta',1),('Marcin',2)) Znajomi(Imie,Numer)
ON #Osoby.ID = Znajomi.Numer
WHEN MATCHED THEN 
UPDATE SET #Osoby.Imie = Znajomi.Imie
WHEN NOT MATCHED THEN
INSERT (imie) values (Znajomi.Imie)
WHEN NOT MATCHED BY SOURCE THEN
DELETE;
SELECT * FROM #Osoby;
